/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */

import { Contract, Signer, utils } from "ethers";
import type { Provider } from "@ethersproject/providers";
import type { IBridge, IBridgeInterface } from "../../contracts/IBridge";

const _abi = [
  {
    anonymous: false,
    inputs: [
      {
        indexed: false,
        internalType: "uint256",
        name: "toChainId",
        type: "uint256",
      },
      {
        indexed: false,
        internalType: "address",
        name: "fromERC20",
        type: "address",
      },
      {
        indexed: false,
        internalType: "address",
        name: "toERC20",
        type: "address",
      },
    ],
    name: "BridgableTokensUpdated",
    type: "event",
  },
  {
    anonymous: false,
    inputs: [
      {
        indexed: false,
        internalType: "uint256",
        name: "fromChainId",
        type: "uint256",
      },
      {
        indexed: false,
        internalType: "uint256",
        name: "toChainId",
        type: "uint256",
      },
      {
        indexed: false,
        internalType: "address",
        name: "fromERC20",
        type: "address",
      },
      {
        indexed: false,
        internalType: "address",
        name: "toERC20",
        type: "address",
      },
      {
        indexed: false,
        internalType: "uint128",
        name: "amount",
        type: "uint128",
      },
      {
        indexed: false,
        internalType: "address",
        name: "receiver",
        type: "address",
      },
    ],
    name: "SwapInitialized",
    type: "event",
  },
  {
    anonymous: false,
    inputs: [
      {
        indexed: false,
        internalType: "address",
        name: "newValidator",
        type: "address",
      },
    ],
    name: "ValidatorUpdated",
    type: "event",
  },
  {
    inputs: [
      {
        internalType: "uint256",
        name: "nonce",
        type: "uint256",
      },
      {
        internalType: "uint256",
        name: "fromChainId",
        type: "uint256",
      },
      {
        internalType: "uint256",
        name: "toChainId",
        type: "uint256",
      },
      {
        internalType: "address",
        name: "fromERC20",
        type: "address",
      },
      {
        internalType: "address",
        name: "toERC20",
        type: "address",
      },
      {
        internalType: "uint128",
        name: "amount",
        type: "uint128",
      },
      {
        internalType: "address",
        name: "receiver",
        type: "address",
      },
      {
        internalType: "uint8",
        name: "v",
        type: "uint8",
      },
      {
        internalType: "bytes32",
        name: "r",
        type: "bytes32",
      },
      {
        internalType: "bytes32",
        name: "s",
        type: "bytes32",
      },
    ],
    name: "checkSign",
    outputs: [
      {
        internalType: "bool",
        name: "",
        type: "bool",
      },
    ],
    stateMutability: "view",
    type: "function",
  },
  {
    inputs: [
      {
        internalType: "uint256",
        name: "nonce",
        type: "uint256",
      },
      {
        internalType: "uint256",
        name: "fromChainId",
        type: "uint256",
      },
      {
        internalType: "uint256",
        name: "toChainId",
        type: "uint256",
      },
      {
        internalType: "address",
        name: "fromERC20",
        type: "address",
      },
      {
        internalType: "address",
        name: "toERC20",
        type: "address",
      },
      {
        internalType: "uint128",
        name: "amount",
        type: "uint128",
      },
      {
        internalType: "address",
        name: "receiver",
        type: "address",
      },
      {
        internalType: "uint8",
        name: "v",
        type: "uint8",
      },
      {
        internalType: "bytes32",
        name: "r",
        type: "bytes32",
      },
      {
        internalType: "bytes32",
        name: "s",
        type: "bytes32",
      },
    ],
    name: "redeem",
    outputs: [],
    stateMutability: "nonpayable",
    type: "function",
  },
  {
    inputs: [
      {
        internalType: "uint256",
        name: "toChainId",
        type: "uint256",
      },
      {
        internalType: "address",
        name: "fromERC20",
        type: "address",
      },
      {
        internalType: "address",
        name: "toERC20",
        type: "address",
      },
      {
        internalType: "uint128",
        name: "amount",
        type: "uint128",
      },
    ],
    name: "swap",
    outputs: [],
    stateMutability: "nonpayable",
    type: "function",
  },
];

export class IBridge__factory {
  static readonly abi = _abi;
  static createInterface(): IBridgeInterface {
    return new utils.Interface(_abi) as IBridgeInterface;
  }
  static connect(
    address: string,
    signerOrProvider: Signer | Provider
  ): IBridge {
    return new Contract(address, _abi, signerOrProvider) as IBridge;
  }
}
